module Postfix where
import Stack

data Token  =  Val Int | Op Char
  deriving Show

type Expr = [Token]

evalStep :: Stack Int -> Token -> Stack Int
evalStep  st (Val i) = push i st
evalStep  st (Op c)
	| c == '+' = push (v2 + v1) st2
	| c == '-' = push (v2 - v1) st2
	| c == '*' = push (v2 * v1) st2
              where
              (v1,st1) = pop st
              (v2,st2) = pop st1

evalExp :: Stack Int -> Expr -> Int
evalExp st [] = fst (pop st)
evalExp st (e:es) = evalExp (evalStep st e) es

evaluate :: Expr -> Int
evaluate exp = evalExp empty exp
