module SortingFns (sort)  where

isort :: (Ord a) =>  [a] -> [a]
isort  l  = foldr insert [] l

insert :: (Ord a) =>  a -> [a] -> [a]
insert  x [] = [x]
insert  x (y:ys)
  | (x <= y)  = x:y:ys
  | otherwise = y : insert  x ys


mergesort :: Ord a => [a] -> [a]
mergesort [] = []
mergesort [x] = [x]
mergesort l = merge (mergesort fhalf) (mergesort shalf)
               where
                 n = div (length l) 2
                 fhalf = take n l
                 shalf = drop n l

merge :: Ord  a => [a] -> [a] -> [a]
merge [] l = l
merge l [] = l
merge (x:xs) (y:ys)
  | (x < y) = x : merge xs (y:ys)
  | otherwise = y : merge (x:xs) ys

sort l = mergesort l
